Package org.apache.groovy.contracts.ast.visitor

# Class BaseVisitor

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.codehaus.groovy.ast.ClassCodeVisitorSupport
org.apache.groovy.contracts.ast.visitor.BaseVisitor

All Implemented Interfaces:
  `GroovyClassVisitor`, `GroovyCodeVisitor`, `ErrorCollecting`

Direct Known Subclasses:
  `AnnotationClosureVisitor`, `AnnotationContractParameterVisitor`, `AnnotationProcessorVisitor`, `ContractElementVisitor`, `DomainModelInjectionVisitor`, `DynamicSetterInjectionVisitor`, `LifecycleAfterTransformationVisitor`, `LifecycleBeforeTransformationVisitor`

public abstract class BaseVisitor extends ClassCodeVisitorSupport

Base class for `ClassCodeVisitorSupport` descendants. This class is used in groovy-contracts as root class for all code visitors directly used by global AST transformations.

See Also:
  - `ClassCodeVisitorSupport`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `GCONTRACTS_ENABLED_VAR`
  `protected final SourceUnit`
  `sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BaseVisitor(SourceUnit sourceUnit, ReaderSource source)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static BooleanExpression`
  `asConditionExecution(AnnotationNode annotation)`
  `protected static ClosureExpression`
  `getOriginalCondition(AnnotationNode annotation)`
  `protected static Expression`
  `getReplacedCondition(AnnotationNode annotation)`
  `protected SourceUnit`
  `getSourceUnit()`
  `protected static void`
  `replaceCondition(AnnotationNode node, Expression expr)`

  ### Methods inherited from class org.codehaus.groovy.ast.ClassCodeVisitorSupport

  `addError, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`

  ### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

  `afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBooleanExpression, visitBytecodeExpression, visitCastExpression, visitClassExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitEmptyStatement, visitFieldExpression, visitGStringExpression, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitTernaryExpression, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.GroovyCodeVisitor

  `visit, visit, visitEmptyExpression, visitListOfExpressions`

- ## Field Details

  - ### GCONTRACTS_ENABLED_VAR

    public static final String GCONTRACTS_ENABLED_VAR
    See Also:
      - Constant Field Values

  - ### sourceUnit

    protected final SourceUnit sourceUnit

- ## Constructor Details

  - ### BaseVisitor

    public BaseVisitor(SourceUnit sourceUnit, ReaderSource source)

- ## Method Details

  - ### getSourceUnit

    protected SourceUnit getSourceUnit()
    Specified by:
      `getSourceUnit` in class `ClassCodeVisitorSupport`

  - ### asConditionExecution

    public static BooleanExpression asConditionExecution(AnnotationNode annotation)

  - ### getOriginalCondition

    protected static ClosureExpression getOriginalCondition(AnnotationNode annotation)

  - ### getReplacedCondition

    protected static Expression getReplacedCondition(AnnotationNode annotation)

  - ### replaceCondition

    protected static void replaceCondition(AnnotationNode node, Expression expr)